### R code from vignette source 's3x.rnw'

###################################################
### code chunk number 1: s3x.rnw:8-11
###################################################
options(width=72,prompt="R> ",continue="   ")
options(SweaveHooks=list(fig=function() par(mar=c(3.9, 4.1, 0.4, 0.1),cex=0.75)))
library (s3x)


###################################################
### code chunk number 2: s3x.rnw:127-129
###################################################
object = list ()
extend (object, "myclass")


###################################################
### code chunk number 3: s3x.rnw:133-136
###################################################
x = 10
y = 20
implant (list (), x, y, z=x + y)


###################################################
### code chunk number 4: s3x.rnw:140-144
###################################################
myclass = function (x, y)
	extend (list (), "myclass", x, y, z=x + y)
myobject = myclass (1, 2)
myobject


###################################################
### code chunk number 5: s3x.rnw:151-152
###################################################
print


###################################################
### code chunk number 6: s3x.rnw:165-168
###################################################
ref = objref (1:3)
ref
deref (ref)


###################################################
### code chunk number 7: s3x.rnw:178-181
###################################################
duplicate = ref
ref [1] = 0
deref (duplicate)


###################################################
### code chunk number 8: s3x.rnw:194-199
###################################################
#a speed object
speed = VECTOR (cars$speed)
speed$unit = "mph"
speed
speed$unit


###################################################
### code chunk number 9: s3x.rnw:202-207
###################################################
#a distance object
distance = VECTOR (cars$dist)
distance$unit = "ft"
distance
distance$unit


###################################################
### code chunk number 10: s3x.rnw:211-213
###################################################
distance [1:10]
distance [[1:10]]


###################################################
### code chunk number 11: s3x.rnw:226-237
###################################################
#table with attributes
table = TABLE (cars)
table$unit_speed = "mph"
table$unit_distance = "ft"
table [1:10,]
table$unit_speed

#like enhanced vectors, double brackets are used to access the elements
table [["speed"]]
#or
table [[,"speed"]]


###################################################
### code chunk number 12: s3x.rnw:241-242
###################################################
objattr (table)


###################################################
### code chunk number 13: s3x.rnw:246-247
###################################################
summary (table)


###################################################
### code chunk number 14: s3x.rnw:255-269
###################################################
straight_line = function (intercept, slope)
{	f_seed = function (x) .$intercept + .$slope * x
	f = FUNCTION (f_seed)
	f$intercept = intercept
	f$slope = slope
	f
}

f1 = straight_line (0, 1)
f2 = straight_line (1, 2)
f1
objattr (f1)
f1 (1:4)
f2 (1:4)


###################################################
### code chunk number 15: s3x.rnw:274-276
###################################################
plot (f1, xlim=c (-5, 5) )
lines (f2, lty=2, xlim=c (-5, 5) )


###################################################
### code chunk number 16: s3x.rnw:288-290
###################################################
table = read_package_data ("rrv", "markowitz.csv")
print (table, 1, row.names=FALSE)


###################################################
### code chunk number 17: s3x.rnw:307-310
###################################################
m = lps_series (trees$Height, trees$Volume, degree=1, smoothness=2, n=5)
plot (trees$Height, trees$Volume)
lines (m)


###################################################
### code chunk number 18: s3x.rnw:314-315
###################################################
m


###################################################
### code chunk number 19: s3x.rnw:322-325
###################################################
x = c (1:2, 4:5)
y = x^2
f = interpolate (x, y)


###################################################
### code chunk number 20: s3x.rnw:330-331
###################################################
plot (f, points=TRUE)


###################################################
### code chunk number 21: s3x.rnw:340-344
###################################################
f = lps_interpolate (trees$Height, trees$Volume, degree=1, smoothness=2, n=5)
plot (trees$Height, trees$Volume)
lines (f)
abline (v=85, h=f (85), lty=2)


###################################################
### code chunk number 22: s3x.rnw:348-349
###################################################
#f (20)


###################################################
### code chunk number 23: s3x.rnw:359-362
###################################################
x = 10e6 * rnorm (10)
vector_style (x)
vector_style (x, 0, currency="$")


###################################################
### code chunk number 24: s3x.rnw:372-375
###################################################
sample (table)
sample (table, 4)
sample (table, 2, 1)


